import ReactDOM from 'react-dom';
var renderUtils = {
  /** ReactDOM */
  createPortal: ReactDOM.createPortal,
  findDOMNode: ReactDOM.findDOMNode,
  unmountComponentAtNode: ReactDOM.unmountComponentAtNode,
  /** document */
  createElement: function createElement() {
    return global.document.createElement(...arguments);
  },
  createDocumentFragment: () => global.document.createDocumentFragment(),
  createComment: data => global.document.createComment(data),
  /** Node */
  appendChild: (el, child) => el.appendChild(child),
  removeChild: (el, child) => el.removeChild(child),
  insertBefore: (el, newNode, referenceNode) => el.insertBefore(newNode, referenceNode),
  replaceChild: (el, node, child) => el.replaceChild(node, child),
  /** ChildNode */
  replaceWith: function replaceWith(el) {
    for (var _len = arguments.length, nodes = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      nodes[_key - 1] = arguments[_key];
    }
    return el.replaceWith(...nodes);
  },
  remove: el => el.remove()
};
export default renderUtils;
//# sourceMappingURL=index.js.map