const _excluded = ["configurable", "enumerable"];
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
export const CAN_USE_DOM = !!(typeof window !== 'undefined' && window.document && window.document.createElement);

// eslint-disable-next-line no-constant-condition
export const freeze = false /** __DEV__* */ ? obj => Object.freeze(obj) : obj => obj;
export function getPossibleHashType(_window = document.defaultView) {
  let locationHash = _window.location.hash.substr(1, 1);
  return !locationHash || locationHash === '/' ? 'slash' : 'noslash';
}
export function clamp(n, lowerBound, upperBound) {
  return Math.min(Math.max(n, lowerBound), upperBound);
}

// function promptBeforeUnload(event: BeforeUnloadEvent) {
//   // Cancel the event.
//   event.preventDefault();
//   // Chrome (and legacy IE) requires returnValue to be set.
//   event.returnValue = '';
// }
export function createEvents() {
  let handlers = [];
  return {
    get length() {
      return handlers.length;
    },
    push(fn) {
      handlers.push(fn);
      return function () {
        handlers = handlers.filter(handler => handler !== fn);
      };
    },
    call(arg, payload) {
      handlers.forEach(fn => fn && fn(arg, payload));
    }
  };
}
export function createKey() {
  return Math.random().toString(36).substr(2, 8);
}
export function getBaseHref() {
  if (!CAN_USE_DOM) return '';
  let base = global.document.querySelector('base');
  let href = '';
  if (base && base.getAttribute('href')) {
    let url = global.location.href;
    let hashIndex = url.indexOf('#');
    href = hashIndex === -1 ? url : url.slice(0, hashIndex);
  }
  return href;
}

/**
 * Creates a string URL path from the given pathname, search, and hash components.
 *
 * @see https://github.com/ReactTraining/history/tree/master/docs/api-reference.md#createpath
 */
export function createPath({
  pathname = '/',
  search = '',
  hash = ''
}) {
  return pathname + search + hash;
}

/**
 * Parses a string URL path into its separate pathname, search, and hash components.
 *
 * @see https://github.com/ReactTraining/history/tree/master/docs/api-reference.md#parsepath
 */
export function parsePath(path) {
  let partialPath = {};
  if (path) {
    let hashIndex = path.indexOf('#');
    if (hashIndex >= 0) {
      partialPath.hash = path.substr(hashIndex);
      path = path.substr(0, hashIndex);
      if (path && !path.startsWith('/')) path = '/' + path;
    }
    let searchIndex = path.indexOf('?');
    if (searchIndex >= 0) {
      partialPath.search = path.substr(searchIndex);
      path = path.substr(0, searchIndex);
      if (path && !path.startsWith('/')) path = '/' + path;
    }
    if (path) {
      partialPath.pathname = path;
    }
  }
  return partialPath;
}
export function createHref(to, hashType) {
  if (!hashType) hashType = getPossibleHashType();
  let path = typeof to === 'string' ? to : createPath(to);
  if (hashType != null) {
    let slashChar = path.substr(0, 1);
    if (hashType === 'slash') {
      if (slashChar !== '/') path = '/' + path;
    } else if (hashType === 'noslash') {
      if (slashChar === '/') path = path.substr(1);
    }
  }
  return path;
}
export function allowTx(blockers, action, location, index, nextIndex, cb) {
  let resultPayload;
  let count = blockers.length;
  function callback(ok, payload) {
    if (!cb) return;
    if (!ok) {
      cb(ok);
      cb = null;
      return;
    }
    if (arguments.length > 1) resultPayload = payload;
    if (! --count) {
      cb(ok, resultPayload);
      cb = null;
    }
  }
  return !blockers.length || (blockers.call({
    action,
    location,
    index,
    nextIndex,
    callback
  }), false);
}
export function readonly(obj, key, get, options) {
  const _ref = options || {},
    {
      configurable = true,
      enumerable = true
    } = _ref,
    restOptions = _objectWithoutProperties(_ref, _excluded);
  Object.defineProperty(obj, key, _objectSpread({
    get,
    configurable,
    enumerable
  }, restOptions));
  return obj;
}