function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
import React from 'react';
import { RouterContext, RouterViewContext } from './context';
function withRouter(comp, {
  withRoute = false
} = {}) {
  return React.forwardRef((props, ref) => React.createElement(RouterContext.Consumer, {}, router => {
    const newProps = _objectSpread(_objectSpread({}, props), {}, {
      ref,
      router: router || null
    });
    if (withRoute) newProps.route = router ? router.currentRoute : null;
    return React.createElement(comp, newProps, props.children);
  }));
}
function withRoute(comp, {
  withRouter = false
} = {}) {
  return React.forwardRef((props, ref) => React.createElement(RouterContext.Consumer, {}, router => {
    const newProps = _objectSpread(_objectSpread({}, props), {}, {
      ref,
      route: router ? router.currentRoute : null
    });
    if (withRouter) newProps.router = router || null;
    return React.createElement(comp, newProps, props.children);
  }));
}
function withRouterView(comp) {
  return React.forwardRef((props, ref) => React.createElement(RouterViewContext.Consumer, {}, routerView => {
    const newProps = _objectSpread(_objectSpread({}, props), {}, {
      ref,
      routerView: routerView || null
    });
    return React.createElement(comp, newProps, props.children);
  }));
}
function withMatchedRouteIndex(comp, {
  withMatchedRoute = false
} = {}) {
  return React.forwardRef((props, ref) => React.createElement(RouterViewContext.Consumer, {}, routerView => {
    const matchedRouteIndex = routerView ? routerView.state.depth : -1;
    const newProps = _objectSpread(_objectSpread({}, props), {}, {
      ref,
      matchedRouteIndex
    });
    if (withMatchedRoute) newProps.matchedRoute = routerView ? routerView.state.currentRoute : null;
    return React.createElement(comp, newProps, props.children);
  }));
}
function withMatchedRoute(comp, {
  withMatchedRouteIndex = false
} = {}) {
  return React.forwardRef((props, ref) => React.createElement(RouterViewContext.Consumer, {}, routerView => {
    const newProps = _objectSpread(_objectSpread({}, props), {}, {
      ref,
      matchedRoute: routerView ? routerView.state.currentRoute : null
    });
    if (withMatchedRouteIndex) newProps.matchedRouteIndex = routerView ? routerView.state.depth : -1;
    return React.createElement(comp, newProps, props.children);
  }));
}
export { withRouter, withRoute, withRouterView, withMatchedRouteIndex, withMatchedRoute };