function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
import React from 'react';
import { innumerable } from './util';
import { REACT_LAZY_TYPE } from './route-guard';
function isEsModule(value) {
  return value && value.__esModule;
}
export class RouteLazy {
  constructor(ctor, options = {}) {
    _defineProperty(this, "_ctor", void 0);
    _defineProperty(this, "_result", void 0);
    _defineProperty(this, "resolved", void 0);
    _defineProperty(this, "routeLazyInstance", void 0);
    _defineProperty(this, "$$typeof", REACT_LAZY_TYPE);
    _defineProperty(this, "options", void 0);
    _defineProperty(this, "updaters", []);
    this._ctor = ctor;
    this._result = null;
    this.routeLazyInstance = true;
    this.options = options;
    this.render = this.render.bind(this);
    this.resolved = false;
    this.updaters = [];
  }
  toResolve(router, route, key) {
    return new Promise(async (resolve, reject) => {
      const _resolve = v => {
        v = isEsModule(v) ? v.default : v;
        const updaters = this.updaters.splice(0, this.updaters.length);
        updaters.forEach(updater => v = updater(v, router) || v);
        if (!this.resolved) {
          this._result = v;
          this.resolved = true;
        }
        resolve(v);
      };
      if (this.resolved) {
        _resolve(this._result);
        return;
      }
      let component = this._ctor.__lazyImportMethod ? this._ctor(route, key, router, this.options) : this._ctor;
      try {
        component = isPromise(component) ? await component : component;
      } catch (ex) {
        reject(ex);
        return;
      }
      if (!component) {
        reject(new Error('component should not null!'));
        return;
      }
      if (component instanceof Promise) {
        component.then(_resolve).catch(function () {
          return reject(...arguments);
        });
      } else _resolve(component);
    });
  }
  render(props, ref) {
    if (!this.resolved || !this._result) return null;
    return React.createElement(this._result, _objectSpread(_objectSpread({}, props), {}, {
      ref
    }), props.children);
  }
}
export function hasRouteLazy(route) {
  const config = route.config || route;
  if (config.components instanceof RouteLazy) return true;
  if (config.components) {
    for (const key of Object.keys(config.components)) {
      if (config.components[key] instanceof RouteLazy) return true;
    }
  }
  return false;
}
export function hasMatchedRouteLazy(matched) {
  return matched && matched.some(r => hasRouteLazy(r));
}
export function lazyImport(importMethod, options = {}) {
  innumerable(importMethod, '__lazyImportMethod', true);
  return new RouteLazy(importMethod, options || {});
}
export function isRouteLazy(value) {
  return value && value.routeLazyInstance;
}
export function isPromise(value) {
  return value && value.then;
}