const _excluded = ["router", "onRouteActive", "onRouteInactive", "onRouteChange", "exact", "activeClass", "exactActiveClass", "tag", "to", "replace", "append", "event", "children"];
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
import React from 'react';
import PropTypes from 'prop-types';
import { camelize, normalizeLocation, getHostRouterView, isPropChanged } from './util';
function guardEvent(e) {
  // don't redirect with control keys
  if (e.metaKey || e.altKey || e.ctrlKey || e.shiftKey) return;
  // don't redirect when preventDefault called
  if (e.defaultPrevented) return;
  // don't redirect on right click
  if (e.button !== undefined && e.button !== 0) return;
  // don't redirect if `target="_blank"`
  if (e.currentTarget && e.currentTarget.getAttribute) {
    const target = e.currentTarget.getAttribute('target');
    if (/\b_blank\b/i.test(target)) return;
  }
  // this may be a Weex event which doesn't have this method
  if (e.preventDefault) {
    e.preventDefault();
  }
  return true;
}
let routerLinkSeed = 0;
class RouterLink extends React.Component {
  constructor(props) {
    super(props);
    _defineProperty(this, "unplugin", void 0);
    const router = props.router;
    this.state = {
      inited: false,
      router,
      routerView: null,
      seed: routerLinkSeed++,
      isMatched: false
    };
  }
  _remount() {
    const {
      seed
    } = this.state;
    let {
      router
    } = this.state;
    if (this.unplugin) {
      this.unplugin();
      this.unplugin = undefined;
    }
    const routerView = router ? router.viewRoot : getHostRouterView(this);
    if (!router && routerView) router = routerView.state.router;
    this.unplugin = router ? router.plugin({
      name: `router-link-plugin-${seed}`,
      onRouteChange: currentRoute => {
        const {
          isMatched: isMatchedOld
        } = this.state;
        const {
          onRouteChange,
          onRouteActive,
          onRouteInactive
        } = this.props;
        const isMatched = this.isMatched(currentRoute);
        this.setState({
          isMatched
        });
        if (isMatched !== isMatchedOld) {
          if (isMatched) onRouteActive && onRouteActive(currentRoute, this);else onRouteInactive && onRouteInactive(currentRoute, this);
        }
        if (onRouteChange) onRouteChange(currentRoute, this);
      }
    }) : undefined;
    const {
      onRouteActive
    } = this.props;
    const isMatched = Boolean(router && this.isMatched(router.currentRoute, routerView));
    if (router && isMatched) onRouteActive && onRouteActive(router.currentRoute, this);
    const state = {
      inited: true,
      router,
      routerView,
      isMatched
    };
    this.setState(state);
  }
  getFallbackClassName(isMatched) {
    const {
      exact
    } = this.props;
    let {
      activeClass,
      exactActiveClass
    } = this.props;
    const {
      router
    } = this.state;
    if (router) {
      if (router.linkActiveClass) {
        activeClass = activeClass ? `${activeClass} ${router.linkActiveClass}` : router.linkActiveClass;
      }
      if (router.linkExactActiveClass) {
        exactActiveClass = exactActiveClass ? `${exactActiveClass} ${router.linkExactActiveClass}` : router.linkExactActiveClass;
      }
    }
    let fallbackClass = '';
    if (isMatched) fallbackClass = exact ? exactActiveClass : activeClass;
    return fallbackClass;
  }
  isMatched(currentRoute = null, routerView = null) {
    const router = this.state.router;
    if (!currentRoute && router) currentRoute = router.currentRoute;
    if (!currentRoute) return false;
    const {
      exact,
      append
    } = this.props;
    let {
      to
    } = this.props;
    if (!routerView) routerView = this.state.routerView;
    to = normalizeLocation(to, {
      route: routerView ? routerView.state.currentRoute : null,
      append,
      queryProps: router && router.queryProps
    });
    let isMatched = false;
    if (to && currentRoute) {
      isMatched = exact ? to.path === currentRoute.path : currentRoute.path.startsWith(to.path);
    }
    return isMatched;
  }
  componentDidMount() {
    this._remount();
  }
  componentWillUnmount() {
    if (this.unplugin) {
      this.unplugin();
      this.unplugin = undefined;
    }
  }
  shouldComponentUpdate(nextProps, nextState) {
    if (isPropChanged(this.props, nextProps)) return true;
    if (this.state.inited !== nextState.inited) return true;
    if (this.state.isMatched !== nextState.isMatched) return true;
    return false;
  }
  componentDidUpdate(prevProps) {
    const newState = {};
    if (this.props.router !== prevProps.router) newState.router = this.props.router;
    // if (this.props.to !== prevProps.to) {
    //   if (!isPlainObject(this.props.to) || !isPlainObject(prevProps.to)
    //     || isPropChanged(this.props.to, prevProps.to)) {
    //     newState.to = this.props.to;
    //   }
    // }
    if (Object.keys(newState).length) {
      this.setState(newState, () => this._remount());
    }
  }
  render() {
    if (!this.state.inited) return null;
    if (!this.props.tag) return this.props.children;
    let _this$props = this.props,
      {
        // eslint-disable-next-line no-unused-vars, prefer-const
        router: router1,
        onRouteActive,
        onRouteInactive,
        onRouteChange,
        exact,
        activeClass,
        exactActiveClass,
        // eslint-disable-next-line prefer-const
        tag,
        to,
        replace,
        append,
        event,
        // eslint-disable-next-line prefer-const
        children = []
      } = _this$props,
      remainProps = _objectWithoutProperties(_this$props, _excluded);
    const {
      router,
      isMatched,
      routerView
    } = this.state;
    const events = {};
    to = normalizeLocation(to, {
      route: routerView ? routerView.state.currentRoute : null,
      append,
      queryProps: router && router.queryProps
    });
    const fallbackClass = this.getFallbackClassName(isMatched);
    if (fallbackClass) {
      if (remainProps.className) remainProps.className = `${fallbackClass} ${remainProps.className}`;else remainProps.className = fallbackClass;
    }
    if (!Array.isArray(event)) event = event ? [event] : [];
    event.forEach(evt => {
      if (!evt) return;
      const eventName = evt.startsWith('on') ? evt : camelize(`on-${evt}`);
      events[eventName] = e => {
        if (!to || !router || remainProps.disabled) return;
        if (remainProps[eventName] && remainProps[eventName](e, to) === false) return;
        guardEvent(e);
        if (replace) router.replace(to);else router.push(to);
      };
    });
    if (to && tag === 'a') remainProps.href = to.path;
    return React.createElement(tag, _objectSpread(_objectSpread({}, remainProps), events), children);
  }
}
_defineProperty(RouterLink, "propTypes", void 0);
_defineProperty(RouterLink, "defaultProps", void 0);
RouterLink.propTypes = {
  className: PropTypes.string,
  to: PropTypes.oneOfType([PropTypes.string, PropTypes.object]).isRequired,
  replace: PropTypes.bool,
  append: PropTypes.bool,
  tag: PropTypes.oneOfType([PropTypes.string, PropTypes.elementType]),
  activeClass: PropTypes.string,
  exact: PropTypes.bool,
  disabled: PropTypes.bool,
  exactActiveClass: PropTypes.string,
  event: PropTypes.oneOfType([PropTypes.string, PropTypes.arrayOf(PropTypes.string)]),
  onRouteChange: PropTypes.func,
  onRouteActive: PropTypes.func,
  onRouteInactive: PropTypes.func
};
RouterLink.defaultProps = {
  tag: '',
  activeClass: 'router-link-active',
  exactActiveClass: 'exact-active-class',
  event: 'click'
};
export { RouterLink, guardEvent };
export default function createRouterLink(router) {
  return React.forwardRef((props, ref) => React.createElement(RouterLink, _objectSpread(_objectSpread({
    router
  }, props), {}, {
    ref
  }), props.children));
}