import _defineProperty from "@babel/runtime/helpers/defineProperty";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["configurable", "enumerable"];
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
import "core-js/modules/es6.array.filter.js";
import "core-js/modules/es6.object.to-string.js";
import "core-js/modules/es6.regexp.to-string.js";
import "core-js/modules/es6.array.slice.js";
import "core-js/modules/es6.regexp.search.js";
import "core-js/modules/es6.symbol.js";
import "core-js/modules/es7.object.get-own-property-descriptors.js";
export var CAN_USE_DOM = !!(typeof window !== 'undefined' && window.document && window.document.createElement);

// eslint-disable-next-line no-constant-condition
export var freeze = false /** __DEV__* */ ? obj => Object.freeze(obj) : obj => obj;
export function getPossibleHashType() {
  var _window = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : document.defaultView;
  var locationHash = _window.location.hash.substr(1, 1);
  return !locationHash || locationHash === '/' ? 'slash' : 'noslash';
}
export function clamp(n, lowerBound, upperBound) {
  return Math.min(Math.max(n, lowerBound), upperBound);
}

// function promptBeforeUnload(event: BeforeUnloadEvent) {
//   // Cancel the event.
//   event.preventDefault();
//   // Chrome (and legacy IE) requires returnValue to be set.
//   event.returnValue = '';
// }
export function createEvents() {
  var handlers = [];
  return {
    get length() {
      return handlers.length;
    },
    push(fn) {
      handlers.push(fn);
      return function () {
        handlers = handlers.filter(handler => handler !== fn);
      };
    },
    call(arg, payload) {
      handlers.forEach(fn => fn && fn(arg, payload));
    }
  };
}
export function createKey() {
  return Math.random().toString(36).substr(2, 8);
}
export function getBaseHref() {
  if (!CAN_USE_DOM) return '';
  var base = global.document.querySelector('base');
  var href = '';
  if (base && base.getAttribute('href')) {
    var url = global.location.href;
    var hashIndex = url.indexOf('#');
    href = hashIndex === -1 ? url : url.slice(0, hashIndex);
  }
  return href;
}

/**
 * Creates a string URL path from the given pathname, search, and hash components.
 *
 * @see https://github.com/ReactTraining/history/tree/master/docs/api-reference.md#createpath
 */
export function createPath(_ref) {
  var _ref$pathname = _ref.pathname,
    pathname = _ref$pathname === void 0 ? '/' : _ref$pathname,
    _ref$search = _ref.search,
    search = _ref$search === void 0 ? '' : _ref$search,
    _ref$hash = _ref.hash,
    hash = _ref$hash === void 0 ? '' : _ref$hash;
  return pathname + search + hash;
}

/**
 * Parses a string URL path into its separate pathname, search, and hash components.
 *
 * @see https://github.com/ReactTraining/history/tree/master/docs/api-reference.md#parsepath
 */
export function parsePath(path) {
  var partialPath = {};
  if (path) {
    var hashIndex = path.indexOf('#');
    if (hashIndex >= 0) {
      partialPath.hash = path.substr(hashIndex);
      path = path.substr(0, hashIndex);
      if (path && !path.startsWith('/')) path = '/' + path;
    }
    var searchIndex = path.indexOf('?');
    if (searchIndex >= 0) {
      partialPath.search = path.substr(searchIndex);
      path = path.substr(0, searchIndex);
      if (path && !path.startsWith('/')) path = '/' + path;
    }
    if (path) {
      partialPath.pathname = path;
    }
  }
  return partialPath;
}
export function createHref(to, hashType) {
  if (!hashType) hashType = getPossibleHashType();
  var path = typeof to === 'string' ? to : createPath(to);
  if (hashType != null) {
    var slashChar = path.substr(0, 1);
    if (hashType === 'slash') {
      if (slashChar !== '/') path = '/' + path;
    } else if (hashType === 'noslash') {
      if (slashChar === '/') path = path.substr(1);
    }
  }
  return path;
}
export function allowTx(blockers, action, location, index, nextIndex, cb) {
  var resultPayload;
  var count = blockers.length;
  function callback(ok, payload) {
    if (!cb) return;
    if (!ok) {
      cb(ok);
      cb = null;
      return;
    }
    if (arguments.length > 1) resultPayload = payload;
    if (! --count) {
      cb(ok, resultPayload);
      cb = null;
    }
  }
  return !blockers.length || (blockers.call({
    action,
    location,
    index,
    nextIndex,
    callback
  }), false);
}
export function readonly(obj, key, get, options) {
  var _ref2 = options || {},
    _ref2$configurable = _ref2.configurable,
    configurable = _ref2$configurable === void 0 ? true : _ref2$configurable,
    _ref2$enumerable = _ref2.enumerable,
    enumerable = _ref2$enumerable === void 0 ? true : _ref2$enumerable,
    restOptions = _objectWithoutProperties(_ref2, _excluded);
  Object.defineProperty(obj, key, _objectSpread({
    get,
    configurable,
    enumerable
  }, restOptions));
  return obj;
}
//# sourceMappingURL=utils.js.map