import "core-js/modules/es6.symbol.js";
import "core-js/modules/es6.array.filter.js";
import "core-js/modules/es7.object.get-own-property-descriptors.js";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
import React from 'react';
import { RouterContext, RouterViewContext } from './context';
function withRouter(comp) {
  var _ref = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
    _ref$withRoute = _ref.withRoute,
    withRoute = _ref$withRoute === void 0 ? false : _ref$withRoute;
  return /*#__PURE__*/React.forwardRef((props, ref) => /*#__PURE__*/React.createElement(RouterContext.Consumer, {}, router => {
    var newProps = _objectSpread(_objectSpread({}, props), {}, {
      ref,
      router: router || null
    });
    if (withRoute) newProps.route = router ? router.currentRoute : null;
    return /*#__PURE__*/React.createElement(comp, newProps, props.children);
  }));
}
function withRoute(comp) {
  var _ref2 = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
    _ref2$withRouter = _ref2.withRouter,
    withRouter = _ref2$withRouter === void 0 ? false : _ref2$withRouter;
  return /*#__PURE__*/React.forwardRef((props, ref) => /*#__PURE__*/React.createElement(RouterContext.Consumer, {}, router => {
    var newProps = _objectSpread(_objectSpread({}, props), {}, {
      ref,
      route: router ? router.currentRoute : null
    });
    if (withRouter) newProps.router = router || null;
    return /*#__PURE__*/React.createElement(comp, newProps, props.children);
  }));
}
function withRouterView(comp) {
  return /*#__PURE__*/React.forwardRef((props, ref) => /*#__PURE__*/React.createElement(RouterViewContext.Consumer, {}, routerView => {
    var newProps = _objectSpread(_objectSpread({}, props), {}, {
      ref,
      routerView: routerView || null
    });
    return /*#__PURE__*/React.createElement(comp, newProps, props.children);
  }));
}
function withMatchedRouteIndex(comp) {
  var _ref3 = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
    _ref3$withMatchedRout = _ref3.withMatchedRoute,
    withMatchedRoute = _ref3$withMatchedRout === void 0 ? false : _ref3$withMatchedRout;
  return /*#__PURE__*/React.forwardRef((props, ref) => /*#__PURE__*/React.createElement(RouterViewContext.Consumer, {}, routerView => {
    var matchedRouteIndex = routerView ? routerView.state.depth : -1;
    var newProps = _objectSpread(_objectSpread({}, props), {}, {
      ref,
      matchedRouteIndex
    });
    if (withMatchedRoute) newProps.matchedRoute = routerView ? routerView.state.currentRoute : null;
    return /*#__PURE__*/React.createElement(comp, newProps, props.children);
  }));
}
function withMatchedRoute(comp) {
  var _ref4 = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
    _ref4$withMatchedRout = _ref4.withMatchedRouteIndex,
    withMatchedRouteIndex = _ref4$withMatchedRout === void 0 ? false : _ref4$withMatchedRout;
  return /*#__PURE__*/React.forwardRef((props, ref) => /*#__PURE__*/React.createElement(RouterViewContext.Consumer, {}, routerView => {
    var newProps = _objectSpread(_objectSpread({}, props), {}, {
      ref,
      matchedRoute: routerView ? routerView.state.currentRoute : null
    });
    if (withMatchedRouteIndex) newProps.matchedRouteIndex = routerView ? routerView.state.depth : -1;
    return /*#__PURE__*/React.createElement(comp, newProps, props.children);
  }));
}
export { withRouter, withRoute, withRouterView, withMatchedRouteIndex, withMatchedRoute };
//# sourceMappingURL=hocs.js.map