import _defineProperty from "@babel/runtime/helpers/defineProperty";
import _asyncToGenerator from "@babel/runtime/helpers/asyncToGenerator";
import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
import "core-js/modules/es7.array.includes.js";
import "core-js/modules/es6.symbol.js";
import "core-js/modules/es6.array.filter.js";
import "core-js/modules/es7.object.get-own-property-descriptors.js";
import _regeneratorRuntime from "@babel/runtime/regenerator";
import { useContext, useState, useEffect, useCallback, useImperativeHandle } from 'react';
import { RouterContext, RouterViewContext } from '../context';
import { _checkActivate, _checkDeactivate } from '../router-view';
import { innumerable, isFunction, isPlainObject, isNumber, readRouteMeta, isEmptyRouteState } from '../util';
function isCommonPage(matched, commonPageName) {
  return Boolean(commonPageName && matched.some(r => readRouteMeta(r.config, commonPageName)));
}
function getRouteMatched(router, currentRoute, commonPageName) {
  if (!currentRoute || !router) return [];
  var _currentRoute$matched = currentRoute.matched,
    matched = _currentRoute$matched === void 0 ? [] : _currentRoute$matched;
  if (matched) {
    var _isCommonPage = isCommonPage(matched, commonPageName);
    if (_isCommonPage && currentRoute.query.redirect) {
      matched = router.getMatched(currentRoute.query.redirect);
    }
  }
  return matched;
}
function useRouter(defaultRouter) {
  // eslint-disable-next-line react-hooks/rules-of-hooks
  return defaultRouter || useContext(RouterContext);
}
function useRoute(defaultRouter) {
  var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var anotherWatch = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
  var router = useRouter(defaultRouter);
  var _useState = useState(router ? router.currentRoute || router.initialRoute : null),
    _useState2 = _slicedToArray(_useState, 2),
    route = _useState2[0],
    setRoute = _useState2[1];
  if (options.watch && router) {
    // eslint-disable-next-line react-hooks/rules-of-hooks
    var onRouteChange = useCallback( /*#__PURE__*/function () {
      var _ref = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee(route, prevRoute, router) {
        return _regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) switch (_context.prev = _context.next) {
            case 0:
              if (!(options.ignoreSamePath !== false && route && prevRoute && route.fullPath === prevRoute.fullPath)) {
                _context.next = 2;
                break;
              }
              return _context.abrupt("return");
            case 2:
              _context.t0 = anotherWatch;
              if (!_context.t0) {
                _context.next = 8;
                break;
              }
              _context.next = 6;
              return anotherWatch(route, prevRoute, router);
            case 6:
              _context.t1 = _context.sent;
              _context.t0 = _context.t1 === false;
            case 8:
              if (!_context.t0) {
                _context.next = 10;
                break;
              }
              return _context.abrupt("return");
            case 10:
              _context.t2 = isFunction(options.watch);
              if (!_context.t2) {
                _context.next = 16;
                break;
              }
              _context.next = 14;
              return options.watch(route, prevRoute, router);
            case 14:
              _context.t3 = _context.sent;
              _context.t2 = _context.t3 === false;
            case 16:
              if (!_context.t2) {
                _context.next = 18;
                break;
              }
              return _context.abrupt("return");
            case 18:
              if (options.delay) setTimeout(() => setRoute(route), isNumber(options.delay) ? options.delay : 0);else setRoute(route);
            case 19:
            case "end":
              return _context.stop();
          }
        }, _callee);
      }));
      return function (_x, _x2, _x3) {
        return _ref.apply(this, arguments);
      };
    }(), [options, anotherWatch]);
    // eslint-disable-next-line react-hooks/rules-of-hooks
    useRouteChanged(router, onRouteChange);
  }
  return route;
}
function useRouterView() {
  return useContext(RouterViewContext);
}
function useMatchedRouteIndex() {
  var matchedOffset = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;
  var view = useRouterView();
  var index = view ? view.state.depth : 0;
  return Math.max(0, index + matchedOffset);
}
function useMatchedRouteAndIndex(defaultRouter) {
  var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var matchedOffset = options.matchedOffset;
  var router = useRouter(defaultRouter);
  var routeIndex = useMatchedRouteIndex(matchedOffset);
  var matchRouteWatch = useCallback((route, prevRoute) => route.matched[routeIndex] !== prevRoute.matched[routeIndex], [routeIndex]);
  var route = useRoute(defaultRouter, options, matchRouteWatch);
  var matched = getRouteMatched(router, route, options.commonPageName);
  var matchedRoute = matched && matched[routeIndex] || null;
  return [matchedRoute, routeIndex];
}
function useMatchedRoute(defaultRouter, options) {
  var ret = useMatchedRouteAndIndex(defaultRouter, options);
  return ret[0];
}
function useRouteMeta(metaKey, defaultRouter, options) {
  var router = useRouter(defaultRouter);
  var route = useMatchedRoute(router, options);
  var meta = route && route.meta;
  var keyIsArray = Array.isArray(metaKey);
  if (keyIsArray && !metaKey.length) throw new Error('metaKey is Empty!');
  var _useState3 = useState(() => keyIsArray ? metaKey.reduce((p, key) => {
      if (!meta) return p;
      p[key] = meta[key];
      return p;
    }, {}) : {
      [metaKey]: meta && meta[metaKey]
    }),
    _useState4 = _slicedToArray(_useState3, 2),
    value = _useState4[0],
    _setValue = _useState4[1];
  var setValue = useCallback(function (newValue) {
    var setAll = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
    if (!meta) return;
    if (!keyIsArray) {
      newValue = {
        [metaKey]: newValue
      };
    } else if (!setAll) {
      newValue = Object.keys(newValue).reduce((p, key) => {
        if (metaKey.includes(key)) p[key] = newValue[key];
        return p;
      }, {});
    }
    var changed = route && router && router.updateRouteMeta(route, newValue, {
      ignoreConfigRoute: options === null || options === void 0 ? void 0 : options.ignoreConfigRoute
    });
    if (!changed) return;
    _setValue(_objectSpread(_objectSpread({}, value), newValue));
  }, [meta, keyIsArray, route, router, value, metaKey, options === null || options === void 0 ? void 0 : options.ignoreConfigRoute]);
  return keyIsArray ? [value, setValue] : [value[metaKey], setValue];
}
function useRouteState(defaultRouter, stateAction, options) {
  var _useState5 = useState(stateAction || {}),
    _useState6 = _slicedToArray(_useState5, 1),
    defaultState = _useState6[0];
  var router = useRouter(defaultRouter);
  var route = useMatchedRoute(router || defaultRouter, options);
  var routeUrl = route && route.url;
  var setRouteState = useCallback(newState => router && router.replaceState(newState, route || undefined),
  // eslint-disable-next-line react-hooks/exhaustive-deps
  [router, routeUrl]);
  var state = route && route.state;
  if (isEmptyRouteState(state) && defaultState) state = defaultState;
  return [state, setRouteState];
}
function useRouteChanged(router, onChange) {
  var deps = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : [];
  var _useState7 = useState({}),
    _useState8 = _slicedToArray(_useState7, 1),
    plugin = _useState8[0];
  plugin.onRouteChange = onChange;
  return useEffect(() => {
    var unplugin = router.plugin(plugin);
    return () => unplugin && unplugin();
    // eslint-disable-next-line react-hooks/exhaustive-deps
  }, [router, plugin, ...deps]);
}
function useRouteMetaChanged(router, onChange) {
  var deps = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : [];
  var _useState9 = useState({}),
    _useState10 = _slicedToArray(_useState9, 1),
    plugin = _useState10[0];
  plugin.onRouteMetaChange = useCallback((newVal, oldVal, route, router) => {
    if (deps.length && !deps.some(v => {
      if (isPlainObject(v)) return v === route.meta;
      return v in oldVal;
    })) return;
    return onChange(newVal, oldVal, route, router);
  }, [deps, onChange]);
  return useEffect(() => {
    var unplugin = router.plugin(plugin);
    return () => unplugin && unplugin();
    // eslint-disable-next-line react-hooks/exhaustive-deps
  }, [router, plugin, ...deps]);
}
function createRouteGuardsRef(ref) {
  if (ref && !ref.__routeGuardInfoHooks) innumerable(ref, '__routeGuardInfoHooks', true);
  return ref;
}
function useRouteGuardsRef(ref, guards) {
  var deps = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : [];
  if (!isFunction(guards)) deps.concat(guards);
  return useImperativeHandle(ref, function () {
    var ret;
    if (isFunction(guards)) ret = guards(...arguments);else ret = guards;
    return createRouteGuardsRef(ret);
  },
  // eslint-disable-next-line react-hooks/exhaustive-deps
  deps);
}
function useRouterViewEvent(name, onEvent, unshift) {
  var view = useRouterView();
  var _useState11 = useState({}),
    _useState12 = _slicedToArray(_useState11, 1),
    $refs = _useState12[0];
  $refs.onEvent = onEvent;
  $refs.unshift = unshift;
  useEffect(() => {
    if (!view) return;
    var fn = function fn() {
      return $refs.onEvent(...arguments);
    };
    view._events[name][$refs.unshift ? 'unshift' : 'push'](fn);
    return () => {
      var idx = view._events[name].indexOf(fn);
      if (~idx) view._events[name].splice(idx, 1);
    };
  }, [$refs, view, name]);
}
function useViewActivate(onEvent) {
  var router = useRouter();
  var current = useMatchedRoute();
  useRouterViewEvent('activate', event => {
    if (!onEvent || !_checkActivate(router, current, event)) return;
    onEvent(event);
  });
}
function useViewDeactivate(onEvent) {
  var router = useRouter();
  var current = useMatchedRoute();
  useRouterViewEvent('deactivate', event => {
    if (!onEvent || !_checkDeactivate(router, current, event)) return;
    onEvent(event);
  }, true);
}
export { isCommonPage, getRouteMatched, useRouter, useRouteChanged, useRouteMetaChanged, useRoute, useRouteMeta, useRouteState, useRouterView, useMatchedRouteIndex, useMatchedRoute, useMatchedRouteAndIndex, useRouteGuardsRef, useRouterViewEvent, useViewActivate, useViewDeactivate, createRouteGuardsRef };
//# sourceMappingURL=base.js.map