import _asyncToGenerator from "@babel/runtime/helpers/asyncToGenerator";
import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
var _excluded = ["name", "mode", "basename"],
  _excluded2 = ["routes", "inheritProps", "rememberInitialRoute", "install", "queryProps"];
import _regeneratorRuntime from "@babel/runtime/regenerator";
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
import "core-js/modules/es6.regexp.replace.js";
import "core-js/modules/es7.array.includes.js";
import "core-js/modules/es6.regexp.search.js";
import "core-js/modules/es6.array.filter.js";
import "core-js/modules/es6.array.map.js";
import "core-js/modules/es6.object.to-string.js";
import "core-js/modules/es6.promise.js";
import "core-js/modules/es6.regexp.match.js";
import "core-js/modules/es7.object.values.js";
import "core-js/modules/es6.array.slice.js";
import "core-js/modules/es6.symbol.js";
import "core-js/modules/es7.object.get-own-property-descriptors.js";
import { createHashHistory, createBrowserHistory, createMemoryHistory, getPossibleHistory } from './history-fix';
import config from './config';
import { flatten, isAbsoluteUrl, innumerable, isPlainObject, getRouterViewPath, getCompleteRoute, normalizeRoutes, normalizeLocation, resolveRedirect, resolveAbort, copyOwnProperties, matchRoutes, isFunction, isLocation, nextTick, once, isRouteGuardInfoHooks, isReadonly, afterInterceptors, getRouteChildren, readRouteMeta, readonly, getLoactionAction, getHostRouterView, camelize, reverseArray, isMatchedRoutePropsChanged, isRoute, walkRoutes, warn, createEmptyRouteState, DEFAULT_STATE_NAME, hasOwnProp, isString, isNumber, isEmptyRouteState } from './util';
import { RouteLazy, hasRouteLazy, hasMatchedRouteLazy } from './route-lazy';
import { getGuardsComponent } from './route-guard';
import { createHashHref, HistoryType } from './history';
var HISTORY_METHS = ['push', 'replace', 'redirect', 'go', 'back', 'forward', 'block'];
var idSeed = 1;

// eslint-disable-next-line no-undef
var version = typeof "2.1.9" === 'undefined' ? undefined : "2.1.9";
class ReactViewRouter {
  constructor() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    _defineProperty(this, "version", version);
    _defineProperty(this, "isReactViewRouterInstance", true);
    _defineProperty(this, "parent", null);
    _defineProperty(this, "children", []);
    _defineProperty(this, "options", {});
    _defineProperty(this, "mode", HistoryType.hash);
    _defineProperty(this, "basename", '');
    _defineProperty(this, "basenameNoSlash", '');
    _defineProperty(this, "name", '');
    _defineProperty(this, "routeNameMap", {});
    _defineProperty(this, "routes", normalizeRoutes([]));
    _defineProperty(this, "stacks", []);
    _defineProperty(this, "plugins", []);
    _defineProperty(this, "beforeEachGuards", []);
    _defineProperty(this, "afterUpdateGuards", []);
    _defineProperty(this, "beforeResolveGuards", []);
    _defineProperty(this, "afterEachGuards", []);
    _defineProperty(this, "resolveNameFns", []);
    _defineProperty(this, "prevRoute", null);
    _defineProperty(this, "currentRoute", null);
    _defineProperty(this, "pendingRoute", null);
    _defineProperty(this, "initialRoute", {});
    _defineProperty(this, "queryProps", {});
    _defineProperty(this, "viewRoot", null);
    _defineProperty(this, "errorCallbacks", []);
    _defineProperty(this, "apps", []);
    _defineProperty(this, "Apps", []);
    _defineProperty(this, "isRunning", false);
    _defineProperty(this, "isHistoryCreater", false);
    _defineProperty(this, "rememberInitialRoute", false);
    // scrollBehavior: ReactViewRouterScrollBehavior|null = null;
    _defineProperty(this, "_history", null);
    _defineProperty(this, "_nexting", null);
    _defineProperty(this, "_interceptorCounter", 0);
    this.id = idSeed++;
    this._initRouter(options);
    this.getHostRouterView = getHostRouterView;
    this.nextTick = nextTick.bind(this);
    this._handleRouteInterceptor = this._handleRouteInterceptor.bind(this);
    this.use(this.options);
    if (!options.manual) this.start(undefined, true);
  }
  _initRouter(options) {
    var name = options.name,
      mode = options.mode,
      basename = options.basename,
      moreOptions = _objectWithoutProperties(options, _excluded);
    if (name != null) this.name = name;
    if (mode != null) {
      if (typeof mode !== 'string') {
        moreOptions.history = mode;
        mode = mode.type;
      }
      if (this.mode !== mode) this.mode = mode;
    }
    if (basename !== undefined) {
      if (basename && !/\/$/.test(basename)) basename += '/';
      this.basename = this.mode === HistoryType.memory && (!moreOptions.history || moreOptions.history.type !== HistoryType.memory) ? '' : basename.replace(/\/{2,}/g, '/');
      this.basenameNoSlash = this.basename ? this.basename.endsWith('/') ? this.basename.substr(0, basename.length - 1) : this.basename : this.basename;
    }
    Object.assign(this.options, moreOptions);
    if (this.options.keepAlive && !this.options.renderUtils) {
      throw new Error('endable keepAlive need "renderUtils", but it cannot be found from router\'s options!');
    }
  }
  _updateParent(parent) {
    if (parent === this) parent = null;
    if (this.parent === parent) return;
    if (parent) {
      if (parent.children && !parent.children.includes(this)) parent.children.push(this);
    } else if (this.parent && this.parent.children) {
      var idx = this.parent.children.indexOf(this);
      if (~idx) this.parent.children.splice(idx, 1);
    }
    this.parent = parent;
  }
  get history() {
    if (this._history) return this._history;
    switch (this.mode) {
      case HistoryType.browser:
        this._history = createBrowserHistory(this.options, this);
        break;
      case HistoryType.memory:
        this._history = createMemoryHistory(this.options, this);
        break;
      default:
        this._history = createHashHistory(this.options, this);
    }
    HISTORY_METHS.forEach(key => {
      if (!this[key] || !this[key].bindThis) return;
      this[key] = this[key].bind(this);
      innumerable(this[key], 'bindThis', true);
    });
    this._history.refresh && this._history.refresh();
    this._history && (this._history.destroy = () => this._history = null);
    return this._history;
  }
  get pluginName() {
    return this.name;
  }
  get top() {
    return this.parent ? this.parent.top : this;
  }
  get isBrowserMode() {
    return this.mode === HistoryType.browser;
  }
  get isHashMode() {
    return this.mode === HistoryType.hash;
  }
  get isMemoryMode() {
    return this.mode === HistoryType.memory;
  }
  get isPrepared() {
    return this.isRunning && Boolean(this.currentRoute && this.viewRoot && this.viewRoot.state.inited && this.viewRoot._isMounted);
  }
  _startHistory() {
    if (this._history && this._history.destroy) this._history.destroy();
    this._unlisten = this.history.listen((_ref, interceptors) => {
      var location = _ref.location;
      var to = location;
      if (interceptors && Array.isArray(interceptors)) {
        var interceptorItem = interceptors.find(v => v.router === this);
        if (interceptorItem && interceptorItem.payload) to = interceptorItem.payload;
      }
      this.updateRoute(to);
    });
    this._uninterceptor = this.history.interceptorTransitionTo(this._handleRouteInterceptor, this);
    this._refreshInitialRoute();
  }
  start() {
    var routerOptions = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    var isInit = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
    this.stop({
      isInit
    });
    this._callEvent('onStart', this, routerOptions, isInit);
    this._initRouter(routerOptions);
    this._startHistory();
    this.isRunning = true;
  }
  stop() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    this._callEvent('onStop', this, options);
    if (this._unlisten) {
      this._unlisten();
      this._unlisten = undefined;
    }
    if (this._uninterceptor) {
      this._uninterceptor();
      this._uninterceptor = undefined;
    }
    if (this._history && this._history.destroy) {
      this._history.destroy();
    }
    this._history = null;
    this._interceptorCounter = 0;
    this.isRunning = false;
    this.isHistoryCreater = false;
    if (!options.ignoreClearRoute) {
      this.initialRoute = {
        location: {}
      };
      this.prevRoute = null;
      this.currentRoute = null;
      this.pendingRoute = null;
    }
  }
  use(_ref2) {
    var routes = _ref2.routes,
      inheritProps = _ref2.inheritProps,
      rememberInitialRoute = _ref2.rememberInitialRoute,
      install = _ref2.install,
      queryProps = _ref2.queryProps,
      restOptions = _objectWithoutProperties(_ref2, _excluded2);
    if (rememberInitialRoute !== undefined) this.rememberInitialRoute = rememberInitialRoute;
    // if (scrollBehavior !== undefined) this.scrollBehavior = scrollBehavior;

    if (queryProps) this.queryProps = queryProps;
    if (routes) {
      var originRoutes = this.routes;
      this.routes = routes ? normalizeRoutes(routes) : normalizeRoutes([]);
      this._callEvent('onRoutesChange', this.routes, originRoutes);
      this._walkRoutes(this.routes);
      if (this._history && this.initialRoute) this._refreshInitialRoute();
    }
    if (inheritProps !== undefined) config.inheritProps = inheritProps;
    Object.assign(config, restOptions);
    if (install) this.install = install.bind(this);
  }
  plugin(plugin) {
    if (isFunction(plugin)) {
      plugin = this.plugins.find(p => p.onRouteChange === plugin) || {
        onRouteChange: plugin
      };
    } else if (~this.plugins.indexOf(plugin)) return;
    var idx = this.plugins.findIndex(p => {
      if (plugin.name) return p.name === plugin.name;
      return p === plugin;
    });
    if (~idx) {
      var _this$plugins$splice = this.plugins.splice(idx, 1, plugin),
        _this$plugins$splice2 = _slicedToArray(_this$plugins$splice, 1),
        old = _this$plugins$splice2[0];
      if (old && old.uninstall) old.uninstall(this);
    } else this.plugins.push(plugin);
    if (plugin.install) plugin.install(this);
    return () => {
      var idx = this.plugins.indexOf(plugin);
      if (~idx) {
        this.plugins.splice(idx, 1);
        if (plugin.uninstall) plugin.uninstall(this);
      }
    };
  }
  _walkRoutes(routes, parent) {
    walkRoutes(routes, (route, routeIndex, rs) => {
      this._callEvent('onWalkRoute', route, routeIndex, rs);
      if (route.name) {
        var name = camelize(route.name);
        if (this.routeNameMap[name]) {
          warn(`[react-view-router] route name '${route.name}'(path is [${route.path}]) is duplicate with [${this.routeNameMap[name]}]`);
        }
        this.routeNameMap[name] = route.path;
      }
    }, parent);
  }
  _refreshInitialRoute() {
    var historyLocation = _objectSpread({}, this.history.realtimeLocation);
    this.updateRoute(historyLocation);
    if (this.rememberInitialRoute) {
      var stack;
      if (this.basename) {
        var stacks = reverseArray(this.history.stacks.concat(historyLocation));
        var basename = this.basenameNoSlash;
        for (var i = 0; i < stacks.length; i++) {
          var currentStack = stacks[i];
          if (!currentStack.pathname.startsWith(basename)) break;
          if (i === stacks.length - 1 || !stacks[i + 1].pathname.startsWith(basename)) {
            stack = currentStack;
            break;
          }
        }
      } else if (this.history.stacks.length) {
        stack = this.history.stacks[0];
      }
      if (stack) {
        var _global;
        historyLocation = this._normalizeLocation({
          pathname: stack.pathname,
          search: stack.search
        });
        if (!this.isMemoryMode && (_global = global) !== null && _global !== void 0 && (_global = _global.location) !== null && _global !== void 0 && _global.search) {
          var query = this.parseQuery(global.location.search, this.queryProps);
          if (this.isHashMode) {
            Object.assign(historyLocation.query, query);
          } else if (this.isBrowserMode) {
            Object.keys(historyLocation.query).forEach(key => {
              if (query[key] !== undefined) historyLocation.query[key] = query[key];
            });
          }
        }
      }
    }
    this.initialRoute = this.createRoute(this._transformLocation(historyLocation));
    // innumerable(this.initialRoute, 'location', location);
  }

  _callEvent(event) {
    for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      args[_key - 1] = arguments[_key];
    }
    var plugin = null;
    try {
      var _ret;
      this.plugins.forEach(p => {
        plugin = p;
        var newRet = p[event] && p[event].call(p, ...args, _ret);
        if (newRet !== undefined) _ret = newRet;
      });
      return _ret;
    } catch (ex) {
      if (plugin && plugin.name && ex && ex.message) {
        ex.message = `[${plugin.name}:${event}]${ex.message}`;
      }
      throw ex;
    }
  }
  _isVuelikeComponent(comp) {
    return comp && this.vuelike && (
    // eslint-disable-next-line no-proto
    comp.__proto__ && comp.isVuelikeComponentInstance || comp.__vuelike || comp.__vuelikeComponentClass);
  }
  _getComponentGurads(mr, guardName, onBindInstance, onGetLazyResovle) {
    var _this = this;
    var ret = [];
    var componentInstances = mr.componentInstances;
    var getGuard = (obj, guardName) => {
      var guard = obj && obj[guardName];
      if (guard) innumerable(guard, 'instance', obj);
      return guard;
    };

    // route config
    var routeGuardName = guardName.replace('Route', '');
    var r = mr.config;
    var guards = r[routeGuardName];
    if (guards) ret.push(guards);
    var toResovle = (c, componentKey) => {
      var ret = [];
      if (c) {
        var cc = c.__component ? getGuardsComponent(c, true) : c;
        var cg = getGuard(c.__guards, guardName);
        if (cg) ret.push(cg);
        var ccg = cc && getGuard(cc.prototype, guardName);
        if (ccg) {
          if (this.vuelike && !ccg.isMobxFlow && cc.__flows && ~cc.__flows.indexOf(guardName)) ccg = this.vuelike.flow(ccg);
          ret.push(ccg);
        }
        if (this._isVuelikeComponent(cc) && Array.isArray(cc.mixins)) {
          cc.mixins.forEach(m => {
            var ccg = m && (getGuard(m, guardName) || getGuard(m.prototype, guardName));
            if (!ccg) return;
            if (this.vuelike && !ccg.isMobxFlow && m.__flows && ~m.__flows.indexOf(guardName)) ccg = this.vuelike.flow(ccg);
            ret.push(ccg);
          });
        }
      }
      var ci = componentInstances[componentKey];
      if (isRouteGuardInfoHooks(ci)) {
        var cig = getGuard(ci, guardName);
        if (cig) ret.push(cig);
      }
      if (onBindInstance) ret = ret.map(v => onBindInstance(v, componentKey, ci, mr)).filter(Boolean);else if (ci) {
        ret = ret.map(v => {
          var ret = v.bind(ci);
          ret.instance = v.instance;
          return ret;
        });
      }
      ret = flatten(ret);
      ret.forEach(v => v.route = mr);
      return ret;
    };
    var replaceInterceptors = (newInterceptors, interceptors, index) => {
      interceptors.splice(index, 1, ...newInterceptors);
      return interceptors[index];
    };

    // route component
    r.components && Object.keys(r.components).forEach(key => {
      var c = r.components[key];
      if (!c) return;
      var isResolved = this._callEvent('onGetRouteComponentGurads', ret, r, c, key, guardName, {
        router: this,
        onBindInstance,
        onGetLazyResovle,
        toResovle,
        getGuard,
        replaceInterceptors: replaceInterceptors
      });
      if (isResolved === true) return ret;
      if (c instanceof RouteLazy) {
        var lazyResovleCb;
        var lazyResovle = /*#__PURE__*/function () {
          var _ref3 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee(interceptors, index) {
            var nc, ret;
            return _regeneratorRuntime.wrap(function _callee$(_context) {
              while (1) switch (_context.prev = _context.next) {
                case 0:
                  lazyResovleCb && lazyResovleCb();
                  _context.next = 3;
                  return c.toResolve(_this, r, key);
                case 3:
                  nc = _context.sent;
                  nc = _this._callEvent('onLazyResolveComponent', nc, r) || nc;
                  ret = toResovle(nc, key);
                  return _context.abrupt("return", replaceInterceptors(ret, interceptors, index));
                case 7:
                case "end":
                  return _context.stop();
              }
            }, _callee);
          }));
          return function lazyResovle(_x, _x2) {
            return _ref3.apply(this, arguments);
          };
        }();
        lazyResovle.lazy = true;
        lazyResovle.route = mr;
        onGetLazyResovle && onGetLazyResovle(lazyResovle, cb => lazyResovleCb = cb);
        ret.push(lazyResovle);
        return;
      }
      ret.push(...toResovle(c, key));
    });
    return ret;
  }
  _getSameMatched(route, compare) {
    var ret = [];
    if (!compare) return [];
    route && route.matched.some((tr, i) => {
      var fr = compare.matched[i];
      if (tr.path !== fr.path) return true;
      ret.push(tr);
    });
    return ret.filter(r => !r.redirect);
  }
  _getChangeMatched(route, route2) {
    var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
    var ret = [];
    if (!route2) return [...route.matched];
    var start = false;
    route && route.matched.some((tr, i) => {
      var fr = route2.matched[i];
      if (!start) {
        start = options.containLazy && hasRouteLazy(tr) || !fr || fr.path !== tr.path || Boolean(options.compare && options.compare(tr, fr));
        if (!start) return;
      }
      ret.push(tr);
      var count = options.count;
      if (isFunction(count)) count = count(ret, tr, fr);
      return isNumber(count) && ret.length === count;
    });
    return ret.filter(r => !r.redirect);
  }
  _getBeforeEachGuards(to, from) {
    var current = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
    var ret = [...this.beforeEachGuards];
    if (this.viewRoot && this.viewRoot.props.beforeEach) {
      ret.push(this.viewRoot.props.beforeEach);
    }
    // to.matched.forEach(mr => {
    //   Object.keys(mr.viewInstances).forEach(key => {
    //     let view = mr.viewInstances[key];
    //     if (!view || view === this.viewRoot) return;
    //     const beforeEach = view.props.beforeEach;
    //     if (beforeEach) ret.push(beforeEach);
    //   });
    // });

    if (from) {
      var fm = this._getChangeMatched(from, to).filter(r => Object.keys(r.viewInstances).some(key => r.viewInstances[key]));
      reverseArray(fm).forEach(mr => {
        reverseArray(mr.guards.beforeLeave).forEach(g => {
          if (g.called) return;
          if (g.instance) {
            var beforeEnterGuard = mr.guards.beforeEnter.find(g2 => g2.instance === g.instance);
            if (beforeEnterGuard && !beforeEnterGuard.called) return;
          }
          ret.push(g.guard);
        });
      });
    }
    if (to) {
      var tm = this._getChangeMatched(to, from, {
        containLazy: true,
        compare: (tr, fr) => fr.guards.beforeEnter.some(g => !g.called)
      });
      tm.forEach(mr => mr.guards.beforeEnter.forEach(g => {
        if (!g.lazy && g.called) return;
        ret.push(g.guard);
      }));
    }
    return flatten(ret);
  }
  _getBeforeResolveGuards(to, from) {
    var ret = [...this.beforeResolveGuards];
    if (to) {
      var tm = this._getChangeMatched(to, from, {
        compare: (tr, fr) => fr.guards.beforeResolve.some(g => !g.called)
      });
      tm.forEach(mr => {
        mr.guards.beforeResolve.forEach(g => {
          if (g.called) return;
          ret.push(g.guard);
        });
      });
    }
    return flatten(ret);
  }
  _getRouteUpdateGuards(to, from) {
    var ret = [...this.afterUpdateGuards, ...this.afterEachGuards.filter(g => g.update)];
    var fm = [];
    to && to.matched.some((tr, i) => {
      var fr = from && from.matched[i];
      if (!fr || fr.path !== tr.path) return true;
      fm.push(fr);
    });
    reverseArray(fm.filter(r => !r.redirect)).forEach(mr => reverseArray(mr.guards.update).forEach(g => {
      if (g.called) return;
      ret.push(g.guard);
    }));
    return ret;
  }
  _getAfterEachGuards(to, from) {
    var ret = [];
    if (from) {
      var fm = this._getChangeMatched(from, to).filter(r => Object.keys(r.viewInstances).some(key => r.viewInstances[key]));
      reverseArray(fm.filter(r => !r.redirect)).forEach(mr => reverseArray(mr.guards.afterLeave).forEach(g => {
        if (g.called) return;
        ret.push(g.guard);
      }));
    }
    if (this.viewRoot && this.viewRoot.props.afterEach) {
      ret.push(this.viewRoot.props.afterEach);
    }
    ret.push(...this.afterEachGuards);
    return flatten(ret);
  }
  _isMatchBasename(location) {
    if (!this.basename) return true;
    if (location.basename && !location.absolute) return location.basename === this.basename;
    var pathname = location.path || location.pathname;
    return pathname.startsWith(this.basenameNoSlash);
  }
  _transformLocation(location) {
    if (!location || isRoute(location)) return location;
    if (this.basename) {
      var pathname = location.pathname;
      if (!location.absolute && location.basename != null) pathname = location.basename + pathname;else if (pathname.length < this.basename.length) {
        var parent = this.parent;
        while (parent) {
          if (pathname.length >= parent.basename.length) {
            var parentMatched = parent.getMatched(pathname);
            if (parentMatched.length) {
              pathname = parentMatched[parentMatched.length - 1].path + parentMatched.unmatchedPath;
              break;
            }
          }
          parent = parent.parent;
        }
      }
      if (!/\/$/.test(pathname)) pathname += '/';
      var isCurrentBasename = pathname.startsWith(this.basenameNoSlash);
      location = _objectSpread(_objectSpread({}, location), {}, {
        absolute: false
      });
      location.pathname = isCurrentBasename ? location.pathname.substr(this.basename.length - 1) || '/' : '';
      if (location.path !== undefined) location.path = location.pathname;
      location.fullPath = isCurrentBasename ? location.pathname + location.search : '';
      if (isCurrentBasename && location.basename == null) location.basename = this.basename;
    }
    return location;
  }
  _getInterceptor(interceptors, index) {
    var _this2 = this;
    return _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee2() {
      var interceptor, newInterceptor;
      return _regeneratorRuntime.wrap(function _callee2$(_context2) {
        while (1) switch (_context2.prev = _context2.next) {
          case 0:
            interceptor = interceptors[index];
          case 1:
            if (!(interceptor && interceptor.lazy)) {
              _context2.next = 7;
              break;
            }
            _context2.next = 4;
            return interceptor(interceptors, index);
          case 4:
            interceptor = _context2.sent;
            _context2.next = 1;
            break;
          case 7:
            newInterceptor = _this2._callEvent('onGetRouteInterceptor', interceptor, interceptors, index);
            if (newInterceptor && (isFunction(newInterceptor) || newInterceptor.then)) interceptor = newInterceptor;
            return _context2.abrupt("return", interceptor);
          case 10:
          case "end":
            return _context2.stop();
        }
      }, _callee2);
    }))();
  }
  _routetInterceptors(interceptors, to, from, next) {
    var _this3 = this;
    return _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee5() {
      var throwError, isBlock, beforeInterceptor, _beforeInterceptor;
      return _regeneratorRuntime.wrap(function _callee5$(_context5) {
        while (1) switch (_context5.prev = _context5.next) {
          case 0:
            _beforeInterceptor = function _beforeInterceptor3() {
              _beforeInterceptor = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee4(interceptor, index, to, from, next) {
                var _this4 = this;
                var nextWrapper;
                return _regeneratorRuntime.wrap(function _callee4$(_context4) {
                  while (1) switch (_context4.prev = _context4.next) {
                    case 0:
                      if (interceptor) {
                        _context4.next = 2;
                        break;
                      }
                      return _context4.abrupt("return", next());
                    case 2:
                      nextWrapper = this._nexting = once( /*#__PURE__*/function () {
                        var _ref4 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee3(f1) {
                          var nextInterceptor;
                          return _regeneratorRuntime.wrap(function _callee3$(_context3) {
                            while (1) switch (_context3.prev = _context3.next) {
                              case 0:
                                if (!isBlock.call(_this4, f1, interceptor, v => {
                                  f1 = v;
                                })) {
                                  _context3.next = 2;
                                  break;
                                }
                                return _context3.abrupt("return", next(f1));
                              case 2:
                                if (f1 === true) f1 = undefined;
                                _context3.prev = 3;
                                _context3.next = 6;
                                return _this4._getInterceptor(interceptors, ++index);
                              case 6:
                                nextInterceptor = _context3.sent;
                                if (nextInterceptor) {
                                  _context3.next = 9;
                                  break;
                                }
                                return _context3.abrupt("return", next(res => isFunction(f1) && f1(res)));
                              case 9:
                                _context3.next = 11;
                                return beforeInterceptor.call(_this4, nextInterceptor, index, to, from, res => {
                                  var ret = next(res);
                                  if (interceptor.global) isFunction(f1) && f1(res);
                                  return ret;
                                });
                              case 11:
                                return _context3.abrupt("return", _context3.sent);
                              case 14:
                                _context3.prev = 14;
                                _context3.t0 = _context3["catch"](3);
                                throwError = true;
                                console.error(_context3.t0);
                                next(isString(_context3.t0) ? new Error(_context3.t0) : _context3.t0);
                              case 19:
                              case "end":
                                return _context3.stop();
                            }
                          }, _callee3, null, [[3, 14]]);
                        }));
                        return function (_x8) {
                          return _ref4.apply(this, arguments);
                        };
                      }());
                      _context4.next = 5;
                      return interceptor(to, from, nextWrapper, {
                        route: interceptor.route,
                        router: this
                      });
                    case 5:
                      return _context4.abrupt("return", _context4.sent);
                    case 6:
                    case "end":
                      return _context4.stop();
                  }
                }, _callee4, this);
              }));
              return _beforeInterceptor.apply(this, arguments);
            };
            beforeInterceptor = function _beforeInterceptor2(_x3, _x4, _x5, _x6, _x7) {
              return _beforeInterceptor.apply(this, arguments);
            };
            throwError = false;
            isBlock = (v, interceptor, update) => {
              if (throwError) return true;
              var _isLocation = isString(v) || isLocation(v);
              if (_isLocation && interceptor) {
                var _to = isRoute(v) ? v : _this3._normalizeLocation(v, {
                  route: interceptor.route
                });
                v = _to && _this3.createRoute(_to, {
                  action: getLoactionAction(to),
                  from: to,
                  matchedProvider: getCompleteRoute(to) || getCompleteRoute(from),
                  isRedirect: true
                });
                if (v && v.fullPath === to.fullPath) {
                  v = undefined;
                  _isLocation = false;
                } else if (v) update(v);
              }
              return !_this3._history || v === false || _isLocation || v instanceof Error;
            };
            if (!next) {
              _context5.next = 17;
              break;
            }
            _context5.t0 = beforeInterceptor;
            _context5.t1 = _this3;
            _context5.next = 9;
            return _this3._getInterceptor(interceptors, 0);
          case 9:
            _context5.t2 = _context5.sent;
            _context5.t3 = to;
            _context5.t4 = from;
            _context5.t5 = next;
            _context5.next = 15;
            return _context5.t0.call.call(_context5.t0, _context5.t1, _context5.t2, 0, _context5.t3, _context5.t4, _context5.t5);
          case 15:
            _context5.next = 18;
            break;
          case 17:
            afterInterceptors.call(_this3, interceptors, to, from);
          case 18:
          case "end":
            return _context5.stop();
        }
      }, _callee5);
    }))();
  }
  _handleRouteInterceptor(location, callback) {
    var _arguments = arguments,
      _this5 = this;
    return _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee6() {
      var isInit, pathname, url, nexts, error, isContinue;
      return _regeneratorRuntime.wrap(function _callee6$(_context6) {
        while (1) switch (_context6.prev = _context6.next) {
          case 0:
            isInit = _arguments.length > 2 && _arguments[2] !== undefined ? _arguments[2] : false;
            if (_this5.isRunning) {
              _context6.next = 3;
              break;
            }
            return _context6.abrupt("return", callback(true));
          case 3:
            if (!location) {
              _context6.next = 11;
              break;
            }
            pathname = location.path || location.pathname;
            if (isInit && _this5.basename && !location.basename && _this5.history.location.pathname === pathname) {
              if (_this5.parent && _this5.parent.currentRoute) {
                url = _this5.parent.currentRoute.url;
                if (url && _this5.parent.basename) url = _this5.parent.basename.substr(0, _this5.parent.basename.length - 1) + url;
                if (!pathname.startsWith(url)) {
                  if (location.pathname != null) location.pathname = url;
                  if (location.path != null) location.path = url;
                  if (location.query) location.query = _this5.parent.currentRoute.query;
                  if (!isReadonly(location, 'search')) location.search = _this5.parent.currentRoute.search;
                }
              }
            }
            if (!(_this5.pendingRoute && _this5.pendingRoute.fullPath === location.fullPath)) {
              _context6.next = 8;
              break;
            }
            return _context6.abrupt("return", callback(!_this5._nexting));
          case 8:
            if (!(_this5.basename && location.absolute && !pathname.startsWith(_this5.basename))) {
              _context6.next = 10;
              break;
            }
            return _context6.abrupt("return", callback(true));
          case 10:
            location = _this5._transformLocation(location);
          case 11:
            if (_this5._isMatchBasename(location)) {
              _context6.next = 13;
              break;
            }
            return _context6.abrupt("return", callback(true));
          case 13:
            if (!(!location || !location.pathname && _this5.currentRoute && !_this5.currentRoute.path)) {
              _context6.next = 15;
              break;
            }
            return _context6.abrupt("return", callback(true));
          case 15:
            if (!(!isInit && !location.onInit && (!_this5.viewRoot || !_this5.viewRoot.state.inited))) {
              _context6.next = 17;
              break;
            }
            return _context6.abrupt("return", callback(true));
          case 17:
            nexts = [];
            isContinue = true;
            _this5._callEvent('onRouteing', ok => {
              if (ok === false) isContinue = false;else if (isLocation(ok)) location = ok;else if (isFunction(ok)) nexts.push(ok);
            });
            _context6.prev = 20;
            _context6.t0 = isContinue;
            if (!_context6.t0) {
              _context6.next = 26;
              break;
            }
            _context6.next = 25;
            return _this5._internalHandleRouteInterceptor(location, callback, isInit);
          case 25:
            _context6.t0 = _context6.sent;
          case 26:
            return _context6.abrupt("return", _context6.t0);
          case 29:
            _context6.prev = 29;
            _context6.t1 = _context6["catch"](20);
            error = _context6.t1;
          case 32:
            _context6.prev = 32;
            nexts.forEach(next => next(Boolean(!isContinue || error), error, {
              location,
              isInit
            }));
            return _context6.finish(32);
          case 35:
          case "end":
            return _context6.stop();
        }
      }, _callee6, null, [[20, 29, 32, 35]]);
    }))();
  }
  _normalizeLocation(to) {
    var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    return normalizeLocation(to, _objectSpread({
      basename: this.basename,
      mode: this.mode,
      queryProps: this.queryProps
    }, options));
  }
  _internalHandleRouteInterceptor(location, callback) {
    var _this6 = this;
    var isInit = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
    var isContinue = false;
    var interceptorCounter = ++this._interceptorCounter;
    try {
      var to = this.createRoute(location, {
        matchedProvider: hasOwnProp(location, 'basename') && location.basename !== this.basename ? this.currentRoute : null
      });
      var from = isInit ? null : to.redirectedFrom && to.redirectedFrom.basename === this.basename ? to.redirectedFrom : this.currentRoute;
      var current = this.currentRoute;
      var checkIsContinue = () => !to.path || this.isRunning && interceptorCounter === this._interceptorCounter && Boolean(this.viewRoot && this.viewRoot._isMounted);
      var afterCallback = function afterCallback(isContinue, to) {
        var isRouteAbort = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;
        var ok = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : undefined;
        if (isContinue) to.onInit && to.onInit(isContinue, to);else if (isRouteAbort) {
          _this6._callEvent('onRouteAbort', to, ok);
          to.onAbort && to.onAbort(isContinue, to, ok);
        }
        _this6.nextTick(() => {
          if (!checkIsContinue()) return;
          if (!isInit && (!current || current.fullPath !== to.fullPath)) {
            _this6._routetInterceptors(_this6._getRouteUpdateGuards(to, current), to, current);
          }
        });
      };
      if (!to) return;
      var realtimeLocation = this.history.realtimeLocation;
      if (from && from.isComplete && (!realtimeLocation || realtimeLocation.pathname === this.history.location.pathname) && to.matchedPath === from.matchedPath) {
        isContinue = checkIsContinue();
        if (isContinue) {
          callback(newIsContinue => {
            afterCallback(newIsContinue, to);
          }, to);
        } else callback(isContinue, to);
        return;
      }
      var fallbackViews = [];
      if (hasMatchedRouteLazy(to.matched)) {
        this.viewRoot && fallbackViews.push(this.viewRoot);
        reverseArray(this._getSameMatched(isInit ? null : this.currentRoute, to)).some(m => {
          var keys = Object.keys(m.viewInstances).filter(key => m.viewInstances[key] && m.viewInstances[key].props.fallback);
          if (!keys.length) return;
          return fallbackViews = keys.map(key => m.viewInstances[key]);
        });
      }
      fallbackViews.forEach(fallbackView => fallbackView._updateResolving(true, to));
      this._routetInterceptors(this._getBeforeEachGuards(to, from, current), to, from, ok => {
        this._nexting = null;
        fallbackViews.length && setTimeout(() => fallbackViews.forEach(fallbackView => fallbackView._updateResolving(false)), 0);
        var resolveOptions = {
          from: to,
          isInit: Boolean(isInit || to.onInit)
        };
        if (resolveOptions.isInit && this.pendingRoute && to.fullPath !== this.pendingRoute.fullPath) {
          ok = this.pendingRoute;
          this.pendingRoute = null;
        }

        // if (isString(ok)) ok = { path: ok };
        isContinue = checkIsContinue() && Boolean(ok === undefined || ok && !(ok instanceof Error) && !isLocation(ok));
        if (isContinue) {
          var toLast = to.matched[to.matched.length - 1];
          if (toLast && toLast.config.exact && toLast.redirect) {
            ok = resolveRedirect(toLast.redirect, toLast, resolveOptions);
            if (ok) isContinue = false;
          }
        }
        if (isContinue && !isLocation(ok)) {
          to.matched.filter(mr => mr.abort).some(r => {
            var abort = resolveAbort(r.abort, r, resolveOptions);
            if (abort) {
              ok = isString(abort) ? new Error(abort) : abort === true ? undefined : abort;
              isContinue = false;
            }
            return abort;
          });
        }
        var onNext = newOk => {
          isContinue = newOk;
          if (isContinue) this._routetInterceptors(this._getBeforeResolveGuards(to, current), to, current);

          // callback(isContinue, to);
          var okIsLocation = isLocation(ok);
          var isRouteAbort = !isContinue && !okIsLocation;
          afterCallback(isContinue, to, isRouteAbort, ok);
          if (!isContinue) {
            if (okIsLocation) {
              return this.redirect(ok, isRouteAbort ? undefined : to.onComplete, isRouteAbort ? undefined : to.onAbort, to.onInit || (isInit ? callback : null), to);
            }
            if (ok instanceof Error) this.errorCallbacks.forEach(cb => cb(ok));
            return;
          }
          this.nextTick(() => {
            if (isFunction(ok)) ok = ok(to);
            if (to && isFunction(to.onComplete)) to.onComplete(Boolean(ok), to);
            this._routetInterceptors(this._getAfterEachGuards(to, current), to, current);
          });
        };
        if (!isContinue) {
          try {
            onNext(isContinue);
          } finally {
            callback(isContinue, to);
          }
          return;
        }
        return callback(onNext, to);
      });
    } catch (ex) {
      console.error(ex);
      if (!isContinue) callback(isContinue, null);
    }
  }
  _go(to, onComplete, onAbort, onInit, replace) {
    return new Promise((resolve, reject) => {
      var _global2;
      function doComplete(res, _to) {
        onComplete && onComplete(res, _to);
        resolve(res);
      }
      function doAbort(res, _to) {
        onAbort && onAbort(res, _to);
        reject(res === false && _to === null ? new Error('to path cannot be empty!') : res);
      }
      if (!this.isRunning) {
        doAbort(new Error('router is not running!'), null);
        return;
      }
      var _to;
      try {
        _to = this._normalizeLocation(to, {
          route: to && to.route || this.currentRoute,
          resolvePathCb: (path, to) => {
            var newPath = path.replace(/\[([A-z0-9.\-_#@$%^&*():|?<>=+]+)\]/g, (m, name) => {
              var ret = this.nameToPath(name, to, {
                onComplete: onInit || onComplete,
                onAbort
              });
              if (ret == null) throw new Error(`route name [${name}]not be found!`);
              if (ret === true) throw 'cancel';
              return ret;
            });
            return newPath;
          }
        });
      } catch (ex) {
        if (ex === 'cancel') return;
        throw ex;
      }
      if (!_to) {
        doAbort(false, null);
        return;
      }
      if (isFunction(onComplete)) _to.onComplete = once(doComplete);
      if (isFunction(onAbort)) _to.onAbort = once(doAbort);
      if (onInit) _to.onInit = onInit;
      var holdInitialQueryProps = this.options.holdInitialQueryProps;
      if (holdInitialQueryProps) {
        var query = this.initialRoute.query;
        if (Array.isArray(holdInitialQueryProps)) {
          query = holdInitialQueryProps.reduce((p, key) => {
            var value = query[key];
            if (value === undefined) return p;
            p[key] = value;
            return p;
          }, {});
        } else if (isFunction(holdInitialQueryProps)) {
          query = holdInitialQueryProps(this.initialRoute.query);
        }
        copyOwnProperties(_to.query, query);
      }
      _to.isReplace = Boolean(replace);
      if (this._nexting && (!to.pendingIfNotPrepared || this.isPrepared)) {
        this._nexting(_to);
        return;
      }
      if (_to.fullPath && isAbsoluteUrl(_to.fullPath) && (_global2 = global) !== null && _global2 !== void 0 && _global2.location) {
        if (replace) global.location.replace(_to.fullPath);else global.location.href = _to.fullPath;
        return;
      }
      if (!this.isPrepared && !onInit) {
        this.pendingRoute = _to;
        var location = this.history.realtimeLocation;
        if (_to.fullPath === `${location.pathname}${location.search}`) return;
      } else {
        this.pendingRoute = null;
      }
      var isContinue = onInit || this._callEvent('onRouteGo', to, doComplete, doAbort, Boolean(replace));
      if (isContinue === false) return;
      var history = this.history;
      if (_to.absolute && global.location) {
        var url = '';
        if (this.basename) {
          if (this.top && !this.top.basename) {
            history = this.top.history;
          } else if (!this.isMemoryMode) {
            url = history.createHref(_to);
          }
        } else if (this.isMemoryMode) {
          var mode = isString(_to.absolute) ? _to.absolute : '';
          if (!mode || mode === HistoryType.memory) {
            var guessHistory = getPossibleHistory(this.options);
            if (guessHistory) {
              if (guessHistory.type === HistoryType.memory) history = guessHistory;else {
                mode = guessHistory.type;
                url = guessHistory.createHref(_to);
              }
            } else {
              mode = HistoryType.hash;
              url = createHashHref(_to, this.options.hashType);
            }
            warn(`[react-view-router] warning: parent router mode is ${mode || 'unknown'}, it could be '${mode}' mode that to go!`);
          } else url = history.createHref(_to);

          // if (mode === HistoryType.hash) url = getBaseHref() + (url.startsWith('#') ? '' : '#') + url;
        }

        if (url) {
          if (replace) global.location.replace(url);else global.location.href = url;
          return;
        }
      }
      if (_to.backIfVisited && _to.basename === this.basename) {
        var historyIndex = this.history.index;
        var isMatch = _to.backIfVisited === 'full-matcth' ? (to, s) => to.search === s.search : (to, s) => Object.keys(to.query).every(key => to.query[key] == s.query[key]);
        var stack = reverseArray(this.stacks).find(s => {
          var stackPath = this.getMatchedPath(s.pathname);
          var toPath = _to.path || '';
          if (this.basename) toPath = toPath.substr(this.basenameNoSlash.length, toPath.length);
          return stackPath === this.getMatchedPath(toPath) && isMatch(to, s) && s.index <= historyIndex;
        });
        if (stack) {
          this.go(stack);
          return;
        }
      }
      if (replace) history.replace(_to);else history.push(_to);
    });
  }
  _replace(to, onComplete, onAbort, onInit) {
    return this._go(to, onComplete, onAbort, onInit, true);
  }
  _push(to, onComplete, onAbort, onInit) {
    return this._go(to, onComplete, onAbort, onInit);
  }
  resolveRouteName(fn) {
    var _off = () => {
      var idx = this.resolveNameFns.indexOf(fn);
      if (~idx) this.resolveNameFns.splice(idx, 1);
    };
    _off();
    this.resolveNameFns.push(fn);
    return _off;
  }
  nameToPath(name) {
    var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    var events = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
    name = camelize(name);
    var path = this.routeNameMap[name];
    if (path == null) {
      this.resolveNameFns.some(fn => {
        var newPath = fn(name, options, this, events);
        if (typeof newPath !== 'string' && newPath !== true) return;
        path = newPath;
        return true;
      });
    } else if (options.absolute) {
      if (this.basename) path = `${this.basename}${path}`;
    }
    if (path == null && options.absolute && this.parent) {
      path = this.parent.nameToPath(name, options, events);
      if (path != null && this.parent.basename) {
        path = `${this.parent.basename}${path}`;
      }
    }
    return path;
  }
  updateRouteMeta(route, newValue) {
    var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
    if (!route || !route.meta) return;
    var changed = false;
    var oldValue = {};
    Object.keys(newValue).forEach(key => {
      if (route.meta[key] === newValue[key]) return;
      oldValue[key] = route.meta[key];
      changed = true;
    });
    if (!changed) return;
    Object.assign(route.meta, newValue);
    route.metaComputed = null;
    // if (route.config && !options.ignoreConfigRoute) Object.assign(route.config.meta, newValue);

    this._callEvent('onRouteMetaChange', newValue, oldValue, route, this);
    return changed;
  }
  createMatchedRoute(route, match) {
    var _ref5 = match || {},
      url = _ref5.url,
      _ref5$path = _ref5.path,
      path = _ref5$path === void 0 ? route.path : _ref5$path,
      regx = _ref5.regx,
      params = _ref5.params;
    var subpath = route.subpath,
      _route$meta = route.meta,
      meta = _route$meta === void 0 ? {} : _route$meta,
      redirect = route.redirect,
      depth = route.depth;
    function guardToGuardInfo(originGuard, instance) {
      var guardInfo = {
        guard: function matchedRouteGuardWrapper() {
          guardInfo.called = true;
          return originGuard.apply(this, arguments);
        },
        instance: instance || originGuard.instance,
        called: false
      };
      copyOwnProperties(guardInfo.guard, originGuard);
      return guardInfo;
    }
    function guardsToMatchedRouteGuards(guards) {
      return guards.filter(v => !v.lazy).map(v => guardToGuardInfo(v));
    }
    var beforeEnter;
    var beforeResolve;
    var update;
    var beforeLeave;
    var afterLeave;
    var that = this;
    var ret = {
      url,
      path,
      subpath,
      depth,
      regx,
      redirect,
      params,
      componentInstances: {},
      viewInstances: {},
      guards: {
        get beforeEnter() {
          if (beforeEnter) return beforeEnter;
          beforeEnter = [];
          that._getComponentGurads(ret, 'beforeRouteEnter', (fn, name, ci, r) => {
            var ret = function beforeRouteEnterWraper(to, from, next) {
              return fn(to, from, function (cb) {
                if (isFunction(cb)) {
                  var _cb = cb;
                  r.config._pending && (r.config._pending.completeCallbacks[name] = ci => {
                    var res = _cb(ci);
                    that._callEvent('onRouteEnterNext', r, ci, res);
                    return res;
                  });
                  cb = undefined;
                }
                for (var _len2 = arguments.length, args = new Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
                  args[_key2 - 1] = arguments[_key2];
                }
                return next(cb, ...args);
              }, {
                route: r,
                router: that
              });
            };
            var guardInfo = guardToGuardInfo(ret, fn.instance);
            beforeEnter.push(guardInfo);
            return guardInfo.guard;
          }, (lazyResovleFn, hook) => {
            var guardInfo = {
              lazy: true,
              guard: lazyResovleFn
            };
            hook(() => {
              var idx = beforeEnter.indexOf(guardInfo);
              if (~idx) beforeEnter.splice(idx, 1);
            });
            return beforeEnter.push(guardInfo);
          });
          return beforeEnter;
        },
        get beforeResolve() {
          if (beforeResolve) return beforeResolve;
          beforeResolve = guardsToMatchedRouteGuards(that._getComponentGurads(ret, 'beforeRouteResolve'));
          return beforeResolve;
        },
        get update() {
          if (update) return update;
          update = guardsToMatchedRouteGuards(that._getComponentGurads(ret, 'beforeRouteUpdate'));
          return update;
        },
        get beforeLeave() {
          if (beforeLeave) return beforeLeave;
          beforeLeave = [];
          that._getComponentGurads(ret, 'beforeRouteLeave', (fn, name, ci, r) => {
            var ret = function beforeRouteLeaveWraper(to, from, next) {
              return fn.call(ci, to, from, function (cb) {
                if (isFunction(cb)) {
                  var _cb = cb;
                  cb = function cb() {
                    var res = _cb(...arguments);
                    that._callEvent('onRouteLeaveNext', r, ci, res);
                    return res;
                  };
                }
                for (var _len3 = arguments.length, args = new Array(_len3 > 1 ? _len3 - 1 : 0), _key3 = 1; _key3 < _len3; _key3++) {
                  args[_key3 - 1] = arguments[_key3];
                }
                return next(cb, ...args);
              }, {
                route: r,
                router: that
              });
            };
            var guardInfo = guardToGuardInfo(ret, fn.instance);
            beforeLeave.push(guardInfo);
            return guardInfo.guard;
          });
          return beforeLeave;
        },
        get afterLeave() {
          if (afterLeave) return afterLeave;
          afterLeave = guardsToMatchedRouteGuards(that._getComponentGurads(ret, 'afterRouteLeave'));
          return afterLeave;
        }
      },
      config: route
    };
    readonly(ret, 'meta', () => meta);
    var metaComputed;
    Object.defineProperty(ret, 'metaComputed', {
      get() {
        if (metaComputed) return metaComputed;
        metaComputed = Object.keys(meta).reduce((p, key) => {
          readonly(p, key, () => readRouteMeta(route, key, {
            router: this
          }));
          return p;
        }, {});
        return metaComputed;
      },
      set(v) {
        metaComputed = v;
      },
      enumerable: true,
      configurable: true
    });
    if (match.isNull) ret.isNull = true;
    return ret;
  }
  getMatched(to, from, parent) {
    if (!from) from = this.currentRoute;
    // function copyInstance(to: MatchedRoute, from: MatchedRoute | null) {
    //   if (!from) return;
    //   if (from.componentInstances) to.componentInstances = from.componentInstances;
    //   if (from.viewInstances) to.viewInstances = from.viewInstances;
    // }
    function isSameMatch(tr, fr) {
      return fr && tr && fr.path === tr.match.path;
    }
    var matched = matchRoutes(this.routes, to, parent, {
      queryProps: this.queryProps
    });
    var isHistoryLocation = !isRoute(to) && typeof to !== 'string';
    var state = isHistoryLocation && to.state && to.state[this.basename || DEFAULT_STATE_NAME] || {};
    var isSameMatchedRoute = true;
    var ret = matched.map((_ref6, i) => {
      var route = _ref6.route,
        match = _ref6.match;
      var ret;
      var viewInstances;
      if (isSameMatchedRoute && from && i < from.matched.length) {
        var _fr = from.matched[i];
        var _tr = matched[i];
        isSameMatchedRoute = isSameMatch(_tr, _fr);
        if (isSameMatchedRoute) ret = _fr;else if (i && isSameMatch(matched[i - 1], from.matched[i - 1])) viewInstances = _fr.viewInstances;
      }
      if (!ret) {
        ret = this.createMatchedRoute(route, match);
        if (viewInstances) ret.viewInstances = viewInstances;
        ret.state = state[ret.url];
        if (!ret.state || !Object.keys(ret.state).length) ret.state = createEmptyRouteState();
      }
      return ret;
    });
    innumerable(ret, 'unmatchedPath', matched.unmatchedPath || '');
    innumerable(ret, 'first', ret[0]);
    innumerable(ret, 'last', ret[ret.length - 1]);
    return ret;
  }
  getMatchedComponents(to, from, parent) {
    var ret = [];
    this.getMatched(to, from, parent).forEach(r => {
      Array.prototype.push.apply(ret, Object.values(r.componentInstances));
    });
    return ret.filter(Boolean);
  }
  getMatchedViews(to, from, parent) {
    var ret = [];
    this.getMatched(to, from, parent).map(r => {
      Array.prototype.push.apply(Object.values(r.viewInstances));
    });
    return ret.filter(Boolean);
  }
  getMatchedPath() {
    var path = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
    var matched = this.getMatched(path);
    return matched.length ? `${this.basenameNoSlash}${matched[matched.length - 1].path}${matched.unmatchedPath}` : path;
  }
  createRoute(to) {
    var _to2;
    var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    if (isRoute(to)) return to;
    if (isString(to)) to = this._normalizeLocation(to);
    var from = options.from,
      matchedProvider = options.matchedProvider,
      action = options.action;
    if (!from && to) from = to.redirectedFrom || this.currentRoute;
    var matched = to ? this.getMatched(to, matchedProvider || from) : [];
    var last = matched.length ? matched[matched.length - 1] : {
      url: '',
      path: '',
      params: {},
      meta: {},
      metaComputed: {},
      state: {}
    };
    var _ref7 = to || {},
      _ref7$search = _ref7.search,
      search = _ref7$search === void 0 ? '' : _ref7$search,
      query = _ref7.query,
      _ref7$path = _ref7.path,
      path = _ref7$path === void 0 ? '' : _ref7$path,
      _ref7$delta = _ref7.delta,
      delta = _ref7$delta === void 0 ? 0 : _ref7$delta,
      onAbort = _ref7.onAbort,
      onComplete = _ref7.onComplete,
      isRedirect = _ref7.isRedirect,
      isReplace = _ref7.isReplace,
      onInit = _ref7.onInit,
      _ref7$fromEvent = _ref7.fromEvent,
      fromEvent = _ref7$fromEvent === void 0 ? false : _ref7$fromEvent;
    var params = ((_to2 = to) === null || _to2 === void 0 ? void 0 : _to2.params) || {};
    Object.assign(params, last.params);
    var ret = {
      action: action || getLoactionAction(to) || this.history.action,
      url: last.url,
      basename: this.basename,
      path,
      search,
      fullPath: `${path}${search}`,
      isRedirect: Boolean(isRedirect || options.isRedirect),
      isReplace: Boolean(isReplace),
      fromEvent,
      query: query || (search ? config.parseQuery(search, this.queryProps) : {}),
      params,
      matched,
      matchedPath: last.path,
      delta,
      onAbort,
      onComplete,
      isComplete: false
    };
    readonly(ret, 'meta', () => last.meta);
    readonly(ret, 'metaComputed', () => last.metaComputed);
    readonly(ret, 'state', () => last.state);
    // Object.defineProperty(ret, 'fullPath', {
    //   enumerable: true,
    //   configurable: true,
    //   get() {
    //     return `${to.path}${to.search}`;
    //   }
    // });
    innumerable(ret, 'isViewRoute', true);
    Object.defineProperty(ret, 'origin', {
      configurable: true,
      value: to
    });
    if (isRedirect && from && from.basename === this.basename) {
      ret.redirectedFrom = from;
      if (!ret.onAbort && from.onAbort) ret.onAbort = from.onAbort;
      if (!ret.onComplete && from.onComplete) ret.onComplete = from.onComplete;
      if (!ret.onInit && onInit) ret.onInit = onInit;
    }
    return ret;
  }
  updateRoute(location) {
    location = location && this._transformLocation(location);
    if (!location || !this._isMatchBasename(location)) return;
    if (!this.isRunning && (location.path || this.currentRoute && !this.currentRoute.path)) return;
    var prevRoute = this.currentRoute;
    var realtimeLocation = this.history.realtimeLocation;
    if (prevRoute && realtimeLocation && realtimeLocation !== this.history.location) {
      prevRoute = this.createRoute(realtimeLocation, {
        from: prevRoute
      });
    }
    var currentRoute = isRoute(location) ? location : this.createRoute(location, {
      from: prevRoute
    });
    if (prevRoute && prevRoute.fullPath === currentRoute.fullPath && prevRoute.matched.length === currentRoute.matched.length && prevRoute.matched.every((v, i) => v.path === currentRoute.matched[i].path)) return;
    this.prevRoute = prevRoute;
    this.currentRoute = currentRoute;
    if (this.basename) {
      var basename = this.basenameNoSlash;
      var stacks = [];
      var prevStack = null;
      for (var i = this.history.stacks.length - 1; i >= 0; i--) {
        var info = this.history.stacks[i];
        if (!info.pathname.startsWith(basename) || prevStack && prevStack.index <= info.index) break;
        var pathname = info.pathname.substr(basename.length, info.pathname.length);
        if (!pathname) pathname = '/';
        prevStack = _objectSpread(_objectSpread({}, info), {}, {
          pathname
        });
        stacks.unshift(prevStack);
      }
      if (!this.stacks.length && stacks.length) {
        this.stacks.splice(0, this.stacks.length, ...stacks);
      } else {
        var idx = this.stacks.findIndex((currentStack, i) => {
          var newStack = stacks[i];
          if (newStack && currentStack.timestamp === newStack.timestamp) return;
          return true;
        });
        if (idx < 0) idx = 0;
        this.stacks.splice(idx, this.stacks.length - idx, ...stacks.slice(idx, stacks.length));
      }
    } else this.stacks = this.history.stacks;
    var tms = this.prevRoute && this._getChangeMatched(this.prevRoute, this.currentRoute, this.options.updateWhenQueryChange ? {
      count: (ret, tr, fr) => {
        return !fr || tr.path !== fr.path ? ret.length : ret.length + 1;
      },
      compare: (tr, fr) => isMatchedRoutePropsChanged(tr, this)
    } : {
      count: 1
    });
    var called = false;
    var callback = () => {
      if (called) return;
      called = true;
      currentRoute.isComplete = true;
      this._callEvent('onRouteChange', this.currentRoute, this.prevRoute, this);
    };
    if (tms !== null && tms !== void 0 && tms.length) {
      tms.forEach(tm => {
        var keys = Object.keys(tm.viewInstances);
        if (keys.length) {
          keys.forEach((key, i) => {
            var vm = tm && tm.viewInstances[key];
            if (!vm) return;
            if (!vm._isMounted) {
              console.error(`[react-view-router]router-view[${getRouterViewPath(vm)}] is not mounted!`, vm);
              return;
            }
            // let el = findDOMNode(vm);
            // if (!el || !document.body.contains(el)) {
            //   console.error(`[react-view-router]router-view[${getRouterViewPath(vm)}] is removed from dom!`, vm, el);
            // }
            vm._refreshCurrentRoute(undefined, undefined, i === keys.length - 1 ? callback : undefined);
          });
        } else callback();
      });
    } else if (this.viewRoot && this.viewRoot._isMounted) {
      this.viewRoot._refreshCurrentRoute(undefined, undefined, callback);
    }
    if (!called) callback();
  }
  push(to, onComplete, onAbort) {
    return this._push(to, onComplete, onAbort);
  }
  replace(to, onComplete, onAbort) {
    return this._replace(to, onComplete, onAbort);
  }
  redirect(to, onComplete, onAbort, onInit, from) {
    var _to = this._normalizeLocation(to);
    if (!_to) return;
    _to.isRedirect = true;
    _to.redirectedFrom = from || this.currentRoute;
    return _to.isReplace !== false || from && from.fromEvent || onInit ? this._replace(_to, onComplete, onAbort, onInit) : this._push(_to, onComplete, onAbort, onInit);
  }
  go(n) {
    if (typeof n !== 'number') {
      n = n.index - this.history.index;
      if (!n) return;
    }
    return this.history.go(n);
  }
  back() {
    return this.history.back();
  }
  forward() {
    return this.history.forward();
  }
  replaceState(newState, matchedRoute) {
    var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
    if (!this.isRunning || !this.history.replaceState) return;
    var currentRoute = this.currentRoute || this.initialRoute;
    var mr = matchedRoute || currentRoute && currentRoute.matched[currentRoute.matched.length - 1];
    if (!mr) return;
    var state = this.history.location.state || {};
    var routerStateName = this.basename || DEFAULT_STATE_NAME;
    var routeState = state[routerStateName];
    if (!routeState) routeState = state[routerStateName] = {};
    if (options.mergeState) {
      if (!Object.keys(newState).length) return;
      var beMergedState = routeState[mr.url];
      if (!beMergedState || isEmptyRouteState(beMergedState)) beMergedState = routeState[mr.url] = {};
      Object.assign(beMergedState, newState);
    } else mr.state = routeState[mr.url] = newState;
    this.history.replaceState(state);
    return newState;
  }
  replaceQuery(keyOrObj, value) {
    var currentRoute = this.currentRoute;
    if (!keyOrObj || !currentRoute) return;
    var changed = false;
    var _replaceQuery = (key, value) => {
      if (currentRoute.query[key] === value) return;
      if (value === undefined) delete currentRoute.query[key];else currentRoute.query[key] = value;
      changed = true;
    };
    if (isPlainObject(keyOrObj)) Object.keys(keyOrObj).forEach(key => _replaceQuery(key, keyOrObj[key]));else _replaceQuery(keyOrObj, value);
    if (!changed) return;
    currentRoute.search = this.stringifyQuery(currentRoute.query);
    currentRoute.fullPath = `${currentRoute.path}${currentRoute.search}`;
    this.history.replace(`${this.basenameNoSlash}${currentRoute.fullPath}`, currentRoute.state);
  }
  beforeEach(guard) {
    if (!guard || typeof guard !== 'function') return;
    var i = this.beforeEachGuards.indexOf(guard);
    if (~i) this.beforeEachGuards.splice(i, 1);
    guard.global = true;
    this.beforeEachGuards.push(guard);
  }
  beforeResolve(guard) {
    if (!guard || typeof guard !== 'function') return;
    var unwatch = () => {
      var i = this.beforeResolveGuards.indexOf(guard);
      if (~i) this.beforeResolveGuards.splice(i, 1);
    };
    unwatch();
    guard.global = true;
    this.beforeResolveGuards.push(guard);
    return unwatch;
  }
  afterUpdate(guard) {
    if (!guard || typeof guard !== 'function') return;
    var unwatch = () => {
      var i = this.afterUpdateGuards.indexOf(guard);
      if (~i) this.afterUpdateGuards.splice(i, 1);
    };
    unwatch();
    guard.global = true;
    this.afterUpdateGuards.push(guard);
    return unwatch;
  }
  afterEach(guard) {
    var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    if (!guard || typeof guard !== 'function') return;
    var unwatch = () => {
      var i = this.afterEachGuards.indexOf(guard);
      if (~i) this.afterEachGuards.splice(i, 1);
    };
    unwatch();
    guard.global = true;
    guard.update = Boolean(options.watchUpdate);
    this.afterEachGuards.push(guard);
    return unwatch;
  }
  addRoutes(routes, parentRoute) {
    if (!routes) return;
    if (!Array.isArray(routes)) routes = [routes];
    routes = normalizeRoutes(routes, parentRoute);
    this._walkRoutes(routes, parentRoute);
    var children = this.routes;
    if (parentRoute) {
      if (!parentRoute.children) parentRoute.children = normalizeRoutes([], parentRoute);
      children = getRouteChildren(parentRoute.children, parentRoute);
    }
    routes.forEach(r => {
      var i = children.findIndex(v => v.path === r.path);
      if (~i) children.splice(i, 1, r);else children.push(r);
    });
    this._callEvent('onRoutesChange', this.routes, this.routes, parentRoute, children);
    if (!parentRoute && this.viewRoot) this.viewRoot.setState({
      routes: routes
    });
  }
  parseQuery(query, queryProps) {
    return config.parseQuery(query, queryProps);
  }
  stringifyQuery(obj) {
    return config.stringifyQuery(obj);
  }
  onError(callback) {
    var unwatch = () => {
      var idx = this.errorCallbacks.findIndex(cb => cb === callback);
      if (~idx) this.errorCallbacks.splice(idx, 1);
    };
    var idx = this.errorCallbacks.findIndex(cb => cb === callback);
    if (~idx) return unwatch;
    this.errorCallbacks.push(callback);
    return unwatch;
  }
  install(vuelike, _ref8) {
    var App = _ref8.App;
    this.vuelike = vuelike;
    if (App) {
      if (!Array.isArray(App)) App = [App];
      this.Apps.push(...App);
    }
    var observableRoute = () => {
      var currentRoute = this.currentRoute || {
        query: {},
        meta: {}
      };
      currentRoute = vuelike.observable(currentRoute, Object.keys(currentRoute).reduce((p, key) => {
        var d = Object.getOwnPropertyDescriptor(currentRoute, key);
        if (!d || d.get || d.set) return p;
        var v = currentRoute[key];
        if (d.get || d.set) p[key] = vuelike.observable.ref;else {
          p[key] = isPlainObject(v) || Array.isArray(v) ? vuelike.observable.shallow : vuelike.observable;
        }
        return p;
      }, {}));
      return currentRoute;
    };
    if (vuelike.inherit) {
      vuelike.inherit({
        $router: this,
        $route: observableRoute()
      });
    } else if (App) {
      App.forEach(v => {
        if (!v.inherits) v.inherits = {};
        v.inherits.$router = this;
        v.inherits.$route = observableRoute();
      });
    }
    config.inheritProps = false;
    if (vuelike.config.inheritMergeStrategies) {
      if (!vuelike.config.inheritMergeStrategies.$route) {
        vuelike.config.inheritMergeStrategies.$route = config.createMergeStrategie(this);
      }
    } else if (vuelike.config.optionMergeStrategies) {
      if (!vuelike.config.optionMergeStrategies.$route) {
        vuelike.config.optionMergeStrategies.$route = config.createMergeStrategie(this);
      }
    }
    var router = this;
    this.plugin({
      name: 'react-view-router-plugin',
      onRouteChange: vuelike.action(`[react-view-router][${this.id}]onRouteChange`, function (newVal) {
        var route = vuelike.observable(newVal, {}, {
          deep: false
        });
        router.apps.forEach(app => app.$route = route);
        vuelike.inherit('$route', route);
        if (vuelike.inherits.$router !== router) vuelike.inherit('$router', router);
      })
    });
  }
}
_defineProperty(ReactViewRouter, "version", version);
export { version };
export default ReactViewRouter;
//# sourceMappingURL=router.js.map